# quizzer_rest_api

QuizzerRestApi - JavaScript client for quizzer_rest_api
API for quizzer REST Server
This SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 0.0.0
- Package version: 0.0.0
- Build package: io.swagger.codegen.languages.JavascriptClientCodegen

## Installation

### For [Node.js](https://nodejs.org/)

#### npm

To publish the library as a [npm](https://www.npmjs.com/),
please follow the procedure in ["Publishing npm packages"](https://docs.npmjs.com/getting-started/publishing-npm-packages).

Then install it via:

```shell
npm install quizzer_rest_api --save
```

#### git
#
If the library is hosted at a git repository, e.g.
https://github.com/YOUR_USERNAME/quizzer_rest_api
then install it via:

```shell
    npm install YOUR_USERNAME/quizzer_rest_api --save
```

### For browser

The library also works in the browser environment via npm and [browserify](http://browserify.org/). After following
the above steps with Node.js and installing browserify with `npm install -g browserify`,
perform the following (assuming *main.js* is your entry file):

```shell
browserify main.js > bundle.js
```

Then include *bundle.js* in the HTML pages.

## Getting Started

Please follow the [installation](#installation) instruction and execute the following JS code:

```javascript
var QuizzerRestApi = require('quizzer_rest_api');

var api = new QuizzerRestApi.AdminApi()

var opts = { 
  'body': new QuizzerRestApi.MakeUserAdminReq() // {MakeUserAdminReq} request.
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
api.makeUserAdminPOST(opts, callback);

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost:4000/*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*QuizzerRestApi.AdminApi* | [**makeUserAdminPOST**](docs/AdminApi.md#makeUserAdminPOST) | **POST** /makeUserAdmin | make a user admin
*QuizzerRestApi.AdminApi* | [**usersGET**](docs/AdminApi.md#usersGET) | **GET** /getUsers | list users
*QuizzerRestApi.PublicApi* | [**leaderBoardGET**](docs/PublicApi.md#leaderBoardGET) | **GET** /getLeaderBoard | get the leaderboard
*QuizzerRestApi.PublicApi* | [**rootGET**](docs/PublicApi.md#rootGET) | **GET** / | nothing
*QuizzerRestApi.PublicApi* | [**userExistsGET**](docs/PublicApi.md#userExistsGET) | **GET** /getUserExists | check username
*QuizzerRestApi.UserApi* | [**answerQuestionPOST**](docs/UserApi.md#answerQuestionPOST) | **POST** /answerQuestion | answer a Question
*QuizzerRestApi.UserApi* | [**getMyScoresGET**](docs/UserApi.md#getMyScoresGET) | **GET** /getMyScores | get user scores
*QuizzerRestApi.UserApi* | [**getPicGET**](docs/UserApi.md#getPicGET) | **GET** /getPic | get list of quizzes
*QuizzerRestApi.UserApi* | [**getQuizzesGET**](docs/UserApi.md#getQuizzesGET) | **GET** /getQuizzes | get list of quizzes
*QuizzerRestApi.UserApi* | [**loginPOST**](docs/UserApi.md#loginPOST) | **POST** /login | login
*QuizzerRestApi.UserApi* | [**questionGET**](docs/UserApi.md#questionGET) | **GET** /getQuestion | get a question
*QuizzerRestApi.UserApi* | [**registerPOST**](docs/UserApi.md#registerPOST) | **POST** /register | register
*QuizzerRestApi.UserApi* | [**startQuizPOST**](docs/UserApi.md#startQuizPOST) | **POST** /startQuiz | start taking a Quiz


## Documentation for Models

 - [QuizzerRestApi.AnswerQuestion](docs/AnswerQuestion.md)
 - [QuizzerRestApi.AnswerQuestionRes](docs/AnswerQuestionRes.md)
 - [QuizzerRestApi.Error](docs/Error.md)
 - [QuizzerRestApi.LeaderBoard](docs/LeaderBoard.md)
 - [QuizzerRestApi.LeaderBoardLeaderboard](docs/LeaderBoardLeaderboard.md)
 - [QuizzerRestApi.LoginInfo](docs/LoginInfo.md)
 - [QuizzerRestApi.LoginRes](docs/LoginRes.md)
 - [QuizzerRestApi.MakeUserAdminReq](docs/MakeUserAdminReq.md)
 - [QuizzerRestApi.OkRes](docs/OkRes.md)
 - [QuizzerRestApi.Question](docs/Question.md)
 - [QuizzerRestApi.QuestionAnswers](docs/QuestionAnswers.md)
 - [QuizzerRestApi.QuizBrief](docs/QuizBrief.md)
 - [QuizzerRestApi.QuizzesBrief](docs/QuizzesBrief.md)
 - [QuizzerRestApi.RegisterInfo](docs/RegisterInfo.md)
 - [QuizzerRestApi.StartQuizReq](docs/StartQuizReq.md)
 - [QuizzerRestApi.UserScore](docs/UserScore.md)
 - [QuizzerRestApi.UserScores](docs/UserScores.md)
 - [QuizzerRestApi.UsersInfo](docs/UsersInfo.md)
 - [QuizzerRestApi.UsersInfoUsers](docs/UsersInfoUsers.md)


## Documentation for Authorization

 All endpoints do not require authorization.

