# QuizzerRestApi.AdminApi

All URIs are relative to *http://localhost:4000/*

Method | HTTP request | Description
------------- | ------------- | -------------
[**makeUserAdminPOST**](AdminApi.md#makeUserAdminPOST) | **POST** /makeUserAdmin | make a user admin
[**usersGET**](AdminApi.md#usersGET) | **GET** /getUsers | list users


<a name="makeUserAdminPOST"></a>
# **makeUserAdminPOST**
> OkRes makeUserAdminPOST(opts)

make a user admin

give an user admin privileges

### Example
```javascript
var QuizzerRestApi = require('quizzer_rest_api');

var apiInstance = new QuizzerRestApi.AdminApi();

var opts = { 
  'body': new QuizzerRestApi.MakeUserAdminReq() // MakeUserAdminReq | request.
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.makeUserAdminPOST(opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**MakeUserAdminReq**](MakeUserAdminReq.md)| request. | [optional] 

### Return type

[**OkRes**](OkRes.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="usersGET"></a>
# **usersGET**
> UsersInfo usersGET(token)

list users

check list users and their information

### Example
```javascript
var QuizzerRestApi = require('quizzer_rest_api');

var apiInstance = new QuizzerRestApi.AdminApi();

var token = "token_example"; // String | The user's token


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.usersGET(token, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token** | **String**| The user&#39;s token | 

### Return type

[**UsersInfo**](UsersInfo.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

