# QuizzerRestApi.PublicApi

All URIs are relative to *http://localhost:4000/*

Method | HTTP request | Description
------------- | ------------- | -------------
[**leaderBoardGET**](PublicApi.md#leaderBoardGET) | **GET** /getLeaderBoard | get the leaderboard
[**rootGET**](PublicApi.md#rootGET) | **GET** / | nothing
[**userExistsGET**](PublicApi.md#userExistsGET) | **GET** /getUserExists | check username


<a name="leaderBoardGET"></a>
# **leaderBoardGET**
> LeaderBoard leaderBoardGET()

get the leaderboard

get leaderboard with 10 best players

### Example
```javascript
var QuizzerRestApi = require('quizzer_rest_api');

var apiInstance = new QuizzerRestApi.PublicApi();

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.leaderBoardGET(callback);
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**LeaderBoard**](LeaderBoard.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="rootGET"></a>
# **rootGET**
> &#39;String&#39; rootGET()

nothing

just to see if server is awake. 

### Example
```javascript
var QuizzerRestApi = require('quizzer_rest_api');

var apiInstance = new QuizzerRestApi.PublicApi();

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.rootGET(callback);
```

### Parameters
This endpoint does not need any parameter.

### Return type

**&#39;String&#39;**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="userExistsGET"></a>
# **userExistsGET**
> OkRes userExistsGET(user)

check username

check if username exists

### Example
```javascript
var QuizzerRestApi = require('quizzer_rest_api');

var apiInstance = new QuizzerRestApi.PublicApi();

var user = "user_example"; // String | The username


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.userExistsGET(user, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **user** | **String**| The username | 

### Return type

[**OkRes**](OkRes.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

