# QuizzerRestApi.UserApi

All URIs are relative to *http://localhost:4000/*

Method | HTTP request | Description
------------- | ------------- | -------------
[**answerQuestionPOST**](UserApi.md#answerQuestionPOST) | **POST** /answerQuestion | answer a Question
[**getMyScoresGET**](UserApi.md#getMyScoresGET) | **GET** /getMyScores | get user scores
[**getPicGET**](UserApi.md#getPicGET) | **GET** /getPic | get list of quizzes
[**getQuizzesGET**](UserApi.md#getQuizzesGET) | **GET** /getQuizzes | get list of quizzes
[**loginPOST**](UserApi.md#loginPOST) | **POST** /login | login
[**questionGET**](UserApi.md#questionGET) | **GET** /getQuestion | get a question
[**registerPOST**](UserApi.md#registerPOST) | **POST** /register | register
[**startQuizPOST**](UserApi.md#startQuizPOST) | **POST** /startQuiz | start taking a Quiz


<a name="answerQuestionPOST"></a>
# **answerQuestionPOST**
> AnswerQuestionRes answerQuestionPOST(opts)

answer a Question

user sends answer to current question.

### Example
```javascript
var QuizzerRestApi = require('quizzer_rest_api');

var apiInstance = new QuizzerRestApi.UserApi();

var opts = { 
  'body': new QuizzerRestApi.AnswerQuestion() // AnswerQuestion | answer.
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.answerQuestionPOST(opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**AnswerQuestion**](AnswerQuestion.md)| answer. | [optional] 

### Return type

[**AnswerQuestionRes**](AnswerQuestionRes.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getMyScoresGET"></a>
# **getMyScoresGET**
> UserScores getMyScoresGET(token)

get user scores

get list of finished quizzes and scored results

### Example
```javascript
var QuizzerRestApi = require('quizzer_rest_api');

var apiInstance = new QuizzerRestApi.UserApi();

var token = "token_example"; // String | The user's token


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.getMyScoresGET(token, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token** | **String**| The user&#39;s token | 

### Return type

[**UserScores**](UserScores.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getPicGET"></a>
# **getPicGET**
> File getPicGET(token, pic)

get list of quizzes

get brief list of quizzes with description

### Example
```javascript
var QuizzerRestApi = require('quizzer_rest_api');

var apiInstance = new QuizzerRestApi.UserApi();

var token = "token_example"; // String | The user's token

var pic = 56; // Number | The pic id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.getPicGET(token, pic, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token** | **String**| The user&#39;s token | 
 **pic** | **Number**| The pic id | 

### Return type

**File**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getQuizzesGET"></a>
# **getQuizzesGET**
> QuizzesBrief getQuizzesGET(token)

get list of quizzes

get brief list of quizzes with description

### Example
```javascript
var QuizzerRestApi = require('quizzer_rest_api');

var apiInstance = new QuizzerRestApi.UserApi();

var token = "token_example"; // String | The user's token


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.getQuizzesGET(token, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token** | **String**| The user&#39;s token | 

### Return type

[**QuizzesBrief**](QuizzesBrief.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="loginPOST"></a>
# **loginPOST**
> LoginRes loginPOST(opts)

login

user sends credentials and gets token.

### Example
```javascript
var QuizzerRestApi = require('quizzer_rest_api');

var apiInstance = new QuizzerRestApi.UserApi();

var opts = { 
  'body': new QuizzerRestApi.LoginInfo() // LoginInfo | request.
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.loginPOST(opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**LoginInfo**](LoginInfo.md)| request. | [optional] 

### Return type

[**LoginRes**](LoginRes.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="questionGET"></a>
# **questionGET**
> Question questionGET(token)

get a question

get a random question from server

### Example
```javascript
var QuizzerRestApi = require('quizzer_rest_api');

var apiInstance = new QuizzerRestApi.UserApi();

var token = "token_example"; // String | The user's token


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.questionGET(token, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token** | **String**| The user&#39;s token | 

### Return type

[**Question**](Question.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="registerPOST"></a>
# **registerPOST**
> LoginRes registerPOST(opts)

register

user sends initial info and registers.

### Example
```javascript
var QuizzerRestApi = require('quizzer_rest_api');

var apiInstance = new QuizzerRestApi.UserApi();

var opts = { 
  'body': new QuizzerRestApi.RegisterInfo() // RegisterInfo | request.
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.registerPOST(opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**RegisterInfo**](RegisterInfo.md)| request. | [optional] 

### Return type

[**LoginRes**](LoginRes.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="startQuizPOST"></a>
# **startQuizPOST**
> OkRes startQuizPOST(body)

start taking a Quiz

user begins taking a quiz and answering questions.

### Example
```javascript
var QuizzerRestApi = require('quizzer_rest_api');

var apiInstance = new QuizzerRestApi.UserApi();

var body = new QuizzerRestApi.StartQuizReq(); // StartQuizReq | token.


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.startQuizPOST(body, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**StartQuizReq**](StartQuizReq.md)| token. | 

### Return type

[**OkRes**](OkRes.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

