/**
 * Quizzer REST API
 * API for quizzer REST Server
 *
 * OpenAPI spec version: 0.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Error', 'model/MakeUserAdminReq', 'model/OkRes', 'model/UsersInfo'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/Error'), require('../model/MakeUserAdminReq'), require('../model/OkRes'), require('../model/UsersInfo'));
  } else {
    // Browser globals (root is window)
    if (!root.QuizzerRestApi) {
      root.QuizzerRestApi = {};
    }
    root.QuizzerRestApi.AdminApi = factory(root.QuizzerRestApi.ApiClient, root.QuizzerRestApi.Error, root.QuizzerRestApi.MakeUserAdminReq, root.QuizzerRestApi.OkRes, root.QuizzerRestApi.UsersInfo);
  }
}(this, function(ApiClient, Error, MakeUserAdminReq, OkRes, UsersInfo) {
  'use strict';

  /**
   * Admin service.
   * @module api/AdminApi
   * @version 0.0.0
   */

  /**
   * Constructs a new AdminApi. 
   * @alias module:api/AdminApi
   * @class
   * @param {module:ApiClient} apiClient Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the makeUserAdminPOST operation.
     * @callback module:api/AdminApi~makeUserAdminPOSTCallback
     * @param {String} error Error message, if any.
     * @param {module:model/OkRes} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * make a user admin
     * give an user admin privileges
     * @param {Object} opts Optional parameters
     * @param {module:model/MakeUserAdminReq} opts.body request.
     * @param {module:api/AdminApi~makeUserAdminPOSTCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/OkRes}
     */
    this.makeUserAdminPOST = function(opts, callback) {
      opts = opts || {};
      var postBody = opts['body'];


      var pathParams = {
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = OkRes;

      return this.apiClient.callApi(
        '/makeUserAdmin', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the usersGET operation.
     * @callback module:api/AdminApi~usersGETCallback
     * @param {String} error Error message, if any.
     * @param {module:model/UsersInfo} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * list users
     * check list users and their information
     * @param {String} token The user&#39;s token
     * @param {module:api/AdminApi~usersGETCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/UsersInfo}
     */
    this.usersGET = function(token, callback) {
      var postBody = null;

      // verify the required parameter 'token' is set
      if (token == undefined || token == null) {
        throw new Error("Missing the required parameter 'token' when calling usersGET");
      }


      var pathParams = {
      };
      var queryParams = {
        'token': token
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = UsersInfo;

      return this.apiClient.callApi(
        '/getUsers', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
