/**
 * Quizzer REST API
 * API for quizzer REST Server
 *
 * OpenAPI spec version: 0.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Error', 'model/LeaderBoard', 'model/OkRes'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/Error'), require('../model/LeaderBoard'), require('../model/OkRes'));
  } else {
    // Browser globals (root is window)
    if (!root.QuizzerRestApi) {
      root.QuizzerRestApi = {};
    }
    root.QuizzerRestApi.PublicApi = factory(root.QuizzerRestApi.ApiClient, root.QuizzerRestApi.Error, root.QuizzerRestApi.LeaderBoard, root.QuizzerRestApi.OkRes);
  }
}(this, function(ApiClient, Error, LeaderBoard, OkRes) {
  'use strict';

  /**
   * Public service.
   * @module api/PublicApi
   * @version 0.0.0
   */

  /**
   * Constructs a new PublicApi. 
   * @alias module:api/PublicApi
   * @class
   * @param {module:ApiClient} apiClient Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the leaderBoardGET operation.
     * @callback module:api/PublicApi~leaderBoardGETCallback
     * @param {String} error Error message, if any.
     * @param {module:model/LeaderBoard} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * get the leaderboard
     * get leaderboard with 10 best players
     * @param {module:api/PublicApi~leaderBoardGETCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/LeaderBoard}
     */
    this.leaderBoardGET = function(callback) {
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = LeaderBoard;

      return this.apiClient.callApi(
        '/getLeaderBoard', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the rootGET operation.
     * @callback module:api/PublicApi~rootGETCallback
     * @param {String} error Error message, if any.
     * @param {'String'} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * nothing
     * just to see if server is awake. 
     * @param {module:api/PublicApi~rootGETCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link 'String'}
     */
    this.rootGET = function(callback) {
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = 'String';

      return this.apiClient.callApi(
        '/', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the userExistsGET operation.
     * @callback module:api/PublicApi~userExistsGETCallback
     * @param {String} error Error message, if any.
     * @param {module:model/OkRes} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * check username
     * check if username exists
     * @param {String} user The username
     * @param {module:api/PublicApi~userExistsGETCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/OkRes}
     */
    this.userExistsGET = function(user, callback) {
      var postBody = null;

      // verify the required parameter 'user' is set
      if (user == undefined || user == null) {
        throw new Error("Missing the required parameter 'user' when calling userExistsGET");
      }


      var pathParams = {
      };
      var queryParams = {
        'user': user
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = OkRes;

      return this.apiClient.callApi(
        '/getUserExists', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
