/**
 * Quizzer REST API
 * API for quizzer REST Server
 *
 * OpenAPI spec version: 0.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/AnswerQuestion', 'model/AnswerQuestionRes', 'model/Error', 'model/LoginInfo', 'model/LoginRes', 'model/OkRes', 'model/Question', 'model/QuizzesBrief', 'model/RegisterInfo', 'model/StartQuizReq', 'model/UserScores'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/AnswerQuestion'), require('../model/AnswerQuestionRes'), require('../model/Error'), require('../model/LoginInfo'), require('../model/LoginRes'), require('../model/OkRes'), require('../model/Question'), require('../model/QuizzesBrief'), require('../model/RegisterInfo'), require('../model/StartQuizReq'), require('../model/UserScores'));
  } else {
    // Browser globals (root is window)
    if (!root.QuizzerRestApi) {
      root.QuizzerRestApi = {};
    }
    root.QuizzerRestApi.UserApi = factory(root.QuizzerRestApi.ApiClient, root.QuizzerRestApi.AnswerQuestion, root.QuizzerRestApi.AnswerQuestionRes, root.QuizzerRestApi.Error, root.QuizzerRestApi.LoginInfo, root.QuizzerRestApi.LoginRes, root.QuizzerRestApi.OkRes, root.QuizzerRestApi.Question, root.QuizzerRestApi.QuizzesBrief, root.QuizzerRestApi.RegisterInfo, root.QuizzerRestApi.StartQuizReq, root.QuizzerRestApi.UserScores);
  }
}(this, function(ApiClient, AnswerQuestion, AnswerQuestionRes, Error, LoginInfo, LoginRes, OkRes, Question, QuizzesBrief, RegisterInfo, StartQuizReq, UserScores) {
  'use strict';

  /**
   * User service.
   * @module api/UserApi
   * @version 0.0.0
   */

  /**
   * Constructs a new UserApi. 
   * @alias module:api/UserApi
   * @class
   * @param {module:ApiClient} apiClient Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the answerQuestionPOST operation.
     * @callback module:api/UserApi~answerQuestionPOSTCallback
     * @param {String} error Error message, if any.
     * @param {module:model/AnswerQuestionRes} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * answer a Question
     * user sends answer to current question.
     * @param {Object} opts Optional parameters
     * @param {module:model/AnswerQuestion} opts.body answer.
     * @param {module:api/UserApi~answerQuestionPOSTCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/AnswerQuestionRes}
     */
    this.answerQuestionPOST = function(opts, callback) {
      opts = opts || {};
      var postBody = opts['body'];


      var pathParams = {
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = AnswerQuestionRes;

      return this.apiClient.callApi(
        '/answerQuestion', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getMyScoresGET operation.
     * @callback module:api/UserApi~getMyScoresGETCallback
     * @param {String} error Error message, if any.
     * @param {module:model/UserScores} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * get user scores
     * get list of finished quizzes and scored results
     * @param {String} token The user&#39;s token
     * @param {module:api/UserApi~getMyScoresGETCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/UserScores}
     */
    this.getMyScoresGET = function(token, callback) {
      var postBody = null;

      // verify the required parameter 'token' is set
      if (token == undefined || token == null) {
        throw new Error("Missing the required parameter 'token' when calling getMyScoresGET");
      }


      var pathParams = {
      };
      var queryParams = {
        'token': token
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = UserScores;

      return this.apiClient.callApi(
        '/getMyScores', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getPicGET operation.
     * @callback module:api/UserApi~getPicGETCallback
     * @param {String} error Error message, if any.
     * @param {File} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * get list of quizzes
     * get brief list of quizzes with description
     * @param {String} token The user&#39;s token
     * @param {Number} pic The pic id
     * @param {module:api/UserApi~getPicGETCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link File}
     */
    this.getPicGET = function(token, pic, callback) {
      var postBody = null;

      // verify the required parameter 'token' is set
      if (token == undefined || token == null) {
        throw new Error("Missing the required parameter 'token' when calling getPicGET");
      }

      // verify the required parameter 'pic' is set
      if (pic == undefined || pic == null) {
        throw new Error("Missing the required parameter 'pic' when calling getPicGET");
      }


      var pathParams = {
      };
      var queryParams = {
        'token': token,
        'pic': pic
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = File;

      return this.apiClient.callApi(
        '/getPic', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getQuizzesGET operation.
     * @callback module:api/UserApi~getQuizzesGETCallback
     * @param {String} error Error message, if any.
     * @param {module:model/QuizzesBrief} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * get list of quizzes
     * get brief list of quizzes with description
     * @param {String} token The user&#39;s token
     * @param {module:api/UserApi~getQuizzesGETCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/QuizzesBrief}
     */
    this.getQuizzesGET = function(token, callback) {
      var postBody = null;

      // verify the required parameter 'token' is set
      if (token == undefined || token == null) {
        throw new Error("Missing the required parameter 'token' when calling getQuizzesGET");
      }


      var pathParams = {
      };
      var queryParams = {
        'token': token
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = QuizzesBrief;

      return this.apiClient.callApi(
        '/getQuizzes', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the loginPOST operation.
     * @callback module:api/UserApi~loginPOSTCallback
     * @param {String} error Error message, if any.
     * @param {module:model/LoginRes} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * login
     * user sends credentials and gets token.
     * @param {Object} opts Optional parameters
     * @param {module:model/LoginInfo} opts.body request.
     * @param {module:api/UserApi~loginPOSTCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/LoginRes}
     */
    this.loginPOST = function(opts, callback) {
      opts = opts || {};
      var postBody = opts['body'];


      var pathParams = {
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = LoginRes;

      return this.apiClient.callApi(
        '/login', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the questionGET operation.
     * @callback module:api/UserApi~questionGETCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Question} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * get a question
     * get a random question from server
     * @param {String} token The user&#39;s token
     * @param {module:api/UserApi~questionGETCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/Question}
     */
    this.questionGET = function(token, callback) {
      var postBody = null;

      // verify the required parameter 'token' is set
      if (token == undefined || token == null) {
        throw new Error("Missing the required parameter 'token' when calling questionGET");
      }


      var pathParams = {
      };
      var queryParams = {
        'token': token
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = Question;

      return this.apiClient.callApi(
        '/getQuestion', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the registerPOST operation.
     * @callback module:api/UserApi~registerPOSTCallback
     * @param {String} error Error message, if any.
     * @param {module:model/LoginRes} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * register
     * user sends initial info and registers.
     * @param {Object} opts Optional parameters
     * @param {module:model/RegisterInfo} opts.body request.
     * @param {module:api/UserApi~registerPOSTCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/LoginRes}
     */
    this.registerPOST = function(opts, callback) {
      opts = opts || {};
      var postBody = opts['body'];


      var pathParams = {
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = LoginRes;

      return this.apiClient.callApi(
        '/register', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the startQuizPOST operation.
     * @callback module:api/UserApi~startQuizPOSTCallback
     * @param {String} error Error message, if any.
     * @param {module:model/OkRes} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * start taking a Quiz
     * user begins taking a quiz and answering questions.
     * @param {module:model/StartQuizReq} body token.
     * @param {module:api/UserApi~startQuizPOSTCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/OkRes}
     */
    this.startQuizPOST = function(body, callback) {
      var postBody = body;

      // verify the required parameter 'body' is set
      if (body == undefined || body == null) {
        throw new Error("Missing the required parameter 'body' when calling startQuizPOST");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = OkRes;

      return this.apiClient.callApi(
        '/startQuiz', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
